SystemOrganization addCategory: #'HEB-Tarea2'!
SystemOrganization addCategory: #'HEB-Tarea2-Test'!

Object subclass: #EdgesMethod
	instanceVariableNames: 'points beta edgeCuts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!EdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/19/2011 14:19'!
edgesMethodFor: i and: j with: t

	" 
	gets the i^th and the j^th values of array points -> there's an edge between both nodes'
	this method returns the straight value of some t-part of the edge
	"

	| selPoints pi pj fun |
	pi := points at: i.
	pj := points at: j.
	
	selPoints := #(pi pj).
	
	fun := OriginalSFunction new.
	fun initialize: selPoints with: beta.
	
	^ fun s: t.! !

!EdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/19/2011 14:21'!
edgesMethodFor: selPoints with: t

	" 
	gets the i^th and the j^th values of array points -> there's an edge between both nodes'
	this method returns the straight value of some t-part of the edge
	"

	| fun |
	
	fun := OriginalSFunction new.
	fun initialize: selPoints with: beta.
	
	^ fun s: t.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 02:01'!
getBeta
	^ beta.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 14:24'!
getEdgeCuts
	^ edgeCuts.! !

!EdgesMethod methodsFor: 'initialization' stamp: 'Aldo 12/19/2011 14:23'!
initialize: nodes

	points := nodes collect:  #position asArray.
	beta := 1.
	edgeCuts := 5.! !

!EdgesMethod methodsFor: 'initialization' stamp: 'Aldo 12/19/2011 14:23'!
initialize: nodes with: aDouble.

	points := nodes collect:  #position asArray.
	beta := aDouble.
	edgeCuts := 5.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 02:01'!
setBeta: aDouble 
	beta := aDouble.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 14:24'!
setEdgeCuts: aDouble
	edgeCuts := aDouble.! !

!EdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/19/2011 14:47'!
straightEdgeBetween: i and: j
	
	| selPoints pi pj retVals edMeth |
	pi := points at: i.
	pj := points at: j.
	
	selPoints := #(pi pj).
	
	retVals := OrderedCollection new.


	(1 to: edgeCuts) do: [:k | retVals add: (self edgesMethodFor: selPoints with: k) ].! !

Object subclass: #HEBTree
	instanceVariableNames: 'numberOfNodes hebNodes hierarchyMatrix relationMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!HEBTree methodsFor: 'accessing' stamp: 'Aldo 12/14/2011 15:08'!
getNodes
	^ hebNodes.! !

!HEBTree methodsFor: 'initialization' stamp: 'Aldo 12/14/2011 15:06'!
initialize: nds with: hierAdj and: relAdj
	"
	Initializes the HEB Tree by giving it:
		* nds: the nodes (an array of points)
		* hierAdj: the adjacency matrix asotiated with the tree hierarchy
		* relAdj: the adjacency matrix asotiated with the other relation 
	"
	hebNodes := nds.
	numberOfNodes := hebNodes size.
	hierarchyMatrix := hierAdj.
	relationMatrix := relAdj.! !

Object subclass: #NewSFunction
	instanceVariableNames: 'points beta n sFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!NewSFunction methodsFor: 'initialization' stamp: 'Aldo 12/18/2011 16:52'!
initialize: anArrayOfPoints and: aDouble

	points := anArrayOfPoints.
	n := points size.
	beta := aDouble.
	sFunction := OriginalSFunction new.
	sFunction initialize: points and: beta.! !

!NewSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/18/2011 19:21'!
s: t
	|sx  sy s0 sx0 sy0 p1 pN x1 y1 xN yN|
	
	s0 := sFunction s: t.
	sx0 := s0 x.
	sy0 := s0 y.
	
	p1 := points get: 1.
	pN := points get:n.
	
	x1 := p1 x.
	y1 := p1 y.
	
	xN := pN x.
	yN := pN y.
	
	sx := beta * sx0 + (1 - beta)*(x1 + t * (xN-x1)).
	sy := beta * sy0 + (1 - beta)*(y1 + t * (yN-y1)).
	
	sFunction := self.
	
	 ^ (sx @ sy)! !

Object subclass: #OriginalSFunction
	instanceVariableNames: 'points beta n sFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!OriginalSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/18/2011 16:52'!
initialize: anArrayOfPoints and: aDouble

	points := anArrayOfPoints.
	n := points size.
	beta := aDouble.
	sFunction := nil.! !

!OriginalSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/18/2011 16:44'!
s: t

	" 
	Simple spline function 
	
	t is in [0,1]
	
	s: 0 returns p1 := (x1@y1)
	s: 1 returns pN := (xN@yN)
	
	"

	|p1 pN sx sy x1 xN y1 yN|
	p1 := points at: 1.
	pN := points at: n.
	
	x1 := p1 x.
	y1 := p1 y.

	xN := pN x.
	yN := pN y.
	
	sx := (xN-x1)*t + x1.
	sy := (yN-y1)*t + y1.
	
	^ (sx @ sy).! !

Object subclass: #PointsMethod
	instanceVariableNames: 'points beta n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!PointsMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/15/2011 12:21'!
getControlPointAtIndex: i
	
	" 
	P_{i}' = B * P_{i} + (1 - B)(P_{0} + (i/N-1)(P_{N-1} - P_{0}))  
	
	0 to: N-1 -> 1 to: N	
	"
	
	
	^ (beta * (points at: i)) + (1 - beta) * ((points at: 1) + ((i / (n-1) * ((points at:n) - (points at: 1))))).! !

!PointsMethod methodsFor: 'initialization' stamp: 'Aldo 12/14/2011 15:13'!
initialize: anArrayOfPoints and: aDouble

	points := anArrayOfPoints.
	n := points size.
	beta := aDouble.! !
